#include <iostream>
#include <vector>
#pragma GCC optimize("Ofast")
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n;
	cin>>n;
    int a[n];
    for(int i=0;i<n;i++) cin >>a[i];
    vector<pair<int,int> > obm;
    for(int i=0;i<n;i++)
    {
        int mini=i;
        for(int j=i+1;j<n;j++)
        {
            if(a[j]<a[mini]) mini=j;
        }
        if(mini==i) continue;
        obm.push_back({i,mini});
        int b[mini-i+1];
        for(int j=i;j<=mini;j++) b[j-i]=a[mini+i-j];
        for(int j=i;j<=mini;j++) a[j]=b[j-i];
    }
    cout<<obm.size()<<'\n';
    for(int i=0;i<obm.size();i++) cout<< obm[i].first+1<<' '<<obm[i].second+1<<'\n';
}
